unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  TAGraph, TASeries, TAChartUtils, TAChartAxisUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1BarSeries1: TBarSeries;
    procedure Chart1AxisList1MarkToText(var AText: String; AMark: Double);
    procedure Chart1AxisList2MarkToText(var AText: String; AMark: Double);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  MIN = -5000;
  MAX = 11000;
  N = 15;
var
  i: Integer;
  y, dy: Double;
  clr: TColor;
begin
  dy := (MAX - MIN) / (N - 1);
  for i := 1 to N do
  begin
    y := MIN + dy * (i - 1);
    if y < 0 then
      clr := InterpolateRGB(clYellow, clRed, y/MIN)
    else
      clr := InterpolateRGB(clYellow, clGreen, y/MAX);
    Chart1BarSeries1.AddXY(i, y, '', clr);
  end;

  Chart1.BottomAxis.Marks.Source := Chart1BarSeries1.ListSource;
  Chart1.BottomAxis.Marks.Style := smsXValue;
  Chart1.AxisList[2].Marks.Source := Chart1BarSeries1.ListSource;
  Chart1.AxisList[2].Marks.Style := smsXValue;
end;

procedure TForm1.Chart1AxisList1MarkToText(var AText: String; AMark: Double);
var
  idx: Integer;
begin
  idx := trunc(AMark) - 1;
  if Chart1BarSeries1.YValue[idx] < 0 then
    AText := '';
end;

procedure TForm1.Chart1AxisList2MarkToText(var AText: String; AMark: Double);
var
  idx: Integer;
begin
  idx := trunc(AMark) - 1;
  if Chart1BarSeries1.YValue[idx] >= 0 then
    AText := '';
end;

end.

